

<!DOCTYPE html>
<html class="writer-html5" lang="en" >
<head>
  <meta charset="utf-8" />
  
  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  
  <title>API reference &mdash; MilpyWay 1 documentation</title>
  

  
  <link rel="stylesheet" href="_static/css/theme.css" type="text/css" />
  <link rel="stylesheet" href="_static/pygments.css" type="text/css" />

  
  

  
  

  

  
  <!--[if lt IE 9]>
    <script src="_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
    
      <script type="text/javascript" id="documentation_options" data-url_root="./" src="_static/documentation_options.js"></script>
        <script src="_static/jquery.js"></script>
        <script src="_static/underscore.js"></script>
        <script src="_static/doctools.js"></script>
        <script src="_static/language_data.js"></script>
        <script async="async" src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.5/latest.js?config=TeX-AMS-MML_HTMLorMML"></script>
    
    <script type="text/javascript" src="_static/js/theme.js"></script>

    
    <link rel="index" title="Index" href="genindex.html" />
    <link rel="search" title="Search" href="search.html" />
    <link rel="prev" title="Introduction" href="intro.html" /> 
</head>

<body class="wy-body-for-nav">

   
  <div class="wy-grid-for-nav">
    
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >
          

          
            <a href="index.html" class="icon icon-home"> MilpyWay
          

          
          </a>

          
            
            
          

          
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>

          
        </div>

        
        <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
          
            
            
              
            
            
              <p class="caption"><span class="caption-text">Contents:</span></p>
<ul class="current">
<li class="toctree-l1"><a class="reference internal" href="installation.html">Installation instructions</a></li>
<li class="toctree-l1"><a class="reference internal" href="intro.html">Introduction</a></li>
<li class="toctree-l1 current"><a class="current reference internal" href="#">API reference</a><ul>
<li class="toctree-l2"><a class="reference internal" href="#module-MilpyWay.rm_new"><code class="docutils literal notranslate"><span class="pre">MilpyWay</span></code></a><ul>
<li class="toctree-l3"><a class="reference internal" href="#rm-new">rm_new</a></li>
<li class="toctree-l3"><a class="reference internal" href="#fit-model">fit_model</a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="#milpyway-rm-new"><code class="docutils literal notranslate"><span class="pre">MilpyWay.rm_new</span></code></a></li>
<li class="toctree-l2"><a class="reference internal" href="#milpyway-fit-model"><code class="docutils literal notranslate"><span class="pre">MilpyWay.fit_model</span></code></a></li>
</ul>
</li>
</ul>

            
          
        </div>
        
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">

      
      <nav class="wy-nav-top" aria-label="top navigation">
        
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="index.html">MilpyWay</a>
        
      </nav>


      <div class="wy-nav-content">
        
        <div class="rst-content">
        
          

















<div role="navigation" aria-label="breadcrumbs navigation">

  <ul class="wy-breadcrumbs">
    
      <li><a href="index.html" class="icon icon-home"></a> &raquo;</li>
        
      <li>API reference</li>
    
    
      <li class="wy-breadcrumbs-aside">
        
          
            <a href="_sources/reference.rst.txt" rel="nofollow"> View page source</a>
          
        
      </li>
    
  </ul>

  
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
            
  <div class="section" id="api-reference">
<h1>API reference<a class="headerlink" href="#api-reference" title="Permalink to this headline">¶</a></h1>
<div class="section" id="module-MilpyWay.rm_new">
<span id="milpyway"></span><h2><code class="docutils literal notranslate"><span class="pre">MilpyWay</span></code><a class="headerlink" href="#module-MilpyWay.rm_new" title="Permalink to this headline">¶</a></h2>
<div class="section" id="rm-new">
<h3>rm_new<a class="headerlink" href="#rm-new" title="Permalink to this headline">¶</a></h3>
<p>Main functions in the radial migration model</p>
</div>
<span class="target" id="module-MilpyWay.fit_model"></span><div class="section" id="fit-model">
<h3>fit_model<a class="headerlink" href="#fit-model" title="Permalink to this headline">¶</a></h3>
<p>Likelihood function and other fittig functions to data</p>
<p class="rubric">Notes</p>
<p>History</p>
<p>2019-06-11 frankel
2019-06-24 frankel copy from test_fit and clean</p>
</div>
</div>
<div class="section" id="milpyway-rm-new">
<h2><code class="docutils literal notranslate"><span class="pre">MilpyWay.rm_new</span></code><a class="headerlink" href="#milpyway-rm-new" title="Permalink to this headline">¶</a></h2>
<dl class="function">
<dt id="rm_new.SFH_R_1">
<code class="sig-prename descclassname">rm_new.</code><code class="sig-name descname">SFH_R_1</code><span class="sig-paren">(</span><em class="sig-param">t</em>, <em class="sig-param">R</em>, <em class="sig-param">pm</em>, <em class="sig-param">tmin=0.23</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/rm_new.html#SFH_R_1"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#rm_new.SFH_R_1" title="Permalink to this definition">¶</a></dt>
<dd><p>(not normalized) star formation history as a functoin of Galactocentric radius.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>t</strong> (<em>array</em><em> or </em><em>float</em>) – age (Gyr)</p></li>
<li><p><strong>R</strong> (<em>array</em><em> or </em><em>float</em>) – birth radius (kpc)</p></li>
<li><p><strong>pm</strong> (<em>model_parameters class instance</em>) – </p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p></p>
</dd>
<dt class="field-odd">Return type</dt>
<dd class="field-odd"><p>SFH(t, R)</p>
</dd>
</dl>
<p class="rubric">Notes</p>
<dl class="simple">
<dt>function defined and used in inside-out growth paper</dt><dd><p>sub_proj_sel_z/<a href="#id1"><span class="problematic" id="id2">model_</span></a>…_class.py</p>
</dd>
</dl>
<p>History:</p>
<p>2019-05-13 frankel</p>
</dd></dl>

<dl class="function">
<dt id="rm_new.p_birth_radius">
<code class="sig-prename descclassname">rm_new.</code><code class="sig-name descname">p_birth_radius</code><span class="sig-paren">(</span><em class="sig-param">R_0</em>, <em class="sig-param">t</em>, <em class="sig-param">param</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/rm_new.html#p_birth_radius"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#rm_new.p_birth_radius" title="Permalink to this definition">¶</a></dt>
<dd><p>Radial birth profile</p>
<p>arguments:
R_0 = birth radius [kpc] array or float
tau = age or lookback time [Gyr] array or float
model = array of model parameters</p>
</dd></dl>

<dl class="function">
<dt id="rm_new.p_birth">
<code class="sig-prename descclassname">rm_new.</code><code class="sig-name descname">p_birth</code><span class="sig-paren">(</span><em class="sig-param">R0</em>, <em class="sig-param">pm</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/rm_new.html#p_birth"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#rm_new.p_birth" title="Permalink to this definition">¶</a></dt>
<dd><p>Overall radial birth profile (exponential)</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>R0</strong> (<em>array</em><em>,</em>) – birth radius (kpc)</p></li>
<li><p><strong>pm</strong> (<em>model parameters class instance</em>) – </p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p><ul class="simple">
<li><p><em>p(R0 | pm)</em></p></li>
<li><p><em>2019-05-13</em></p></li>
</ul>
</p>
</dd>
</dl>
</dd></dl>

<dl class="class">
<dt id="rm_new.element">
<em class="property">class </em><code class="sig-prename descclassname">rm_new.</code><code class="sig-name descname">element</code><span class="sig-paren">(</span><em class="sig-param">hyperp=None</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/rm_new.html#element"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#rm_new.element" title="Permalink to this definition">¶</a></dt>
<dd><p>Enrichment prescriptions for single element</p>
<dl class="method">
<dt id="rm_new.element.R0_Weinberg">
<code class="sig-name descname">R0_Weinberg</code><span class="sig-paren">(</span><em class="sig-param">fe</em>, <em class="sig-param">t</em>, <em class="sig-param">pm</em>, <em class="sig-param">ytol=0.1</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/rm_new.html#element.R0_Weinberg"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#rm_new.element.R0_Weinberg" title="Permalink to this definition">¶</a></dt>
<dd><p>finds approximate birth radius through Newton-Raphson of the
Weinberg method, to a precision in ytol (in dex in [Fe/H]).</p>
</dd></dl>

<dl class="method">
<dt id="rm_new.element.R0_break">
<code class="sig-name descname">R0_break</code><span class="sig-paren">(</span><em class="sig-param">fe</em>, <em class="sig-param">t</em>, <em class="sig-param">pm</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/rm_new.html#element.R0_break"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#rm_new.element.R0_break" title="Permalink to this definition">¶</a></dt>
<dd><p>finds birth radius through weak chemical tagging:
given metallicity and age –&gt; R0</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>fe</strong> (<em>array</em>) – metallicity</p></li>
<li><p><strong>t</strong> (<em>array</em>) – age</p></li>
<li><p><strong>param</strong> (<em>enrichment_parameters object</em>) – </p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>R0 (kpc), birth radius</p>
</dd>
<dt class="field-odd">Return type</dt>
<dd class="field-odd"><p>array of the same size as fe or t</p>
</dd>
</dl>
<p class="rubric">Notes</p>
<p>History:</p>
<p>2019-08-02 frankel</p>
</dd></dl>

<dl class="method">
<dt id="rm_new.element.R0_element">
<code class="sig-name descname">R0_element</code><span class="sig-paren">(</span><em class="sig-param">fe</em>, <em class="sig-param">t</em>, <em class="sig-param">param</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/rm_new.html#element.R0_element"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#rm_new.element.R0_element" title="Permalink to this definition">¶</a></dt>
<dd><p>finds birth radius through zeak chemical tagging:
given metallicity and age –&gt; R0</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>fe</strong> (<em>array</em>) – metallicity</p></li>
<li><p><strong>t</strong> (<em>array</em>) – age (Gyr)</p></li>
<li><p><strong>param</strong> (<em>enrichment_parameters object</em>) – model parameters</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>R0 birth radius</p>
</dd>
<dt class="field-odd">Return type</dt>
<dd class="field-odd"><p>array</p>
</dd>
</dl>
<p class="rubric">Notes</p>
<p>History:</p>
<p>2019-06-03 frankel</p>
</dd></dl>

<dl class="method">
<dt id="rm_new.element.Weinberg">
<code class="sig-name descname">Weinberg</code><span class="sig-paren">(</span><em class="sig-param">R</em>, <em class="sig-param">t</em>, <em class="sig-param">param</em>, <em class="sig-param">out_sfr=False</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/rm_new.html#element.Weinberg"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#rm_new.element.Weinberg" title="Permalink to this definition">¶</a></dt>
<dd><p>Weinberg’s chemical enrichment model</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>R</strong> (<em>array</em>) – Galactocentric radius [kpc]</p></li>
<li><p><strong>t</strong> (<em>array</em>) – age [Gyr]</p></li>
<li><p><strong>= class instance of model parameters</strong> (<em>param</em>) – param.tsfr = star formation timescale [Gyr]
param.eta  = mass loading factor</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p></p>
</dd>
<dt class="field-odd">Return type</dt>
<dd class="field-odd"><p>two arrays of length len(R) or len(t)</p>
</dd>
</dl>
<p>[Fe/H], [O/H]</p>
</dd></dl>

<dl class="method">
<dt id="rm_new.element.broken">
<code class="sig-name descname">broken</code><span class="sig-paren">(</span><em class="sig-param">R</em>, <em class="sig-param">t</em>, <em class="sig-param">pm</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/rm_new.html#element.broken"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#rm_new.element.broken" title="Permalink to this definition">¶</a></dt>
<dd><p>Radial metallicity profile: broken line
time dependency: f(t) = (1-t/tmax)**gamma</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>R</strong> (<em>array</em>) – galactocentric radius [kpc]</p></li>
<li><p><strong>t</strong> (<em>array</em>) – age [Gyr]</p></li>
<li><p><strong>pm</strong> (<em>class instance of model parameters</em>) – </p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>[X/H](R, t)</p>
</dd>
<dt class="field-odd">Return type</dt>
<dd class="field-odd"><p>array</p>
</dd>
</dl>
<p class="rubric">Notes</p>
<p>Implemented in Frankel+20</p>
<div class="math notranslate nohighlight">
\[fe = fe_\mathrm{max}f(\tau ) + b_{fe} + \nabla(L_{z0})  \frac{L_{z0}}{235~\mathrm{kms^{-1}}}\]</div>
<div class="math notranslate nohighlight">
\[f(\tau ) = \left( 1 - \frac{\tau}{12~\mathrm{Gyr}} \right)^\gamma\]</div>
</dd></dl>

<dl class="method">
<dt id="rm_new.element.expo">
<code class="sig-name descname">expo</code><span class="sig-paren">(</span><em class="sig-param">R</em>, <em class="sig-param">t</em>, <em class="sig-param">param</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/rm_new.html#element.expo"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#rm_new.element.expo" title="Permalink to this definition">¶</a></dt>
<dd><p>radial metallicity profile = straight line
time dependency: exponential</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>R</strong> (<em>array</em>) – Galactocentric radius [kpc]</p></li>
<li><p><strong>t</strong> (<em>array</em>) – age [Gyr]</p></li>
<li><p><strong>param</strong> (<em>class instance of model parametres</em>) – param.Rs = radius if solar abundances [kpc]
param.t_el = present-day enrichment time-scale [Gyr]
param.grad = abundance gradient [dex/kpc]</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>[X/H] values</p>
</dd>
<dt class="field-odd">Return type</dt>
<dd class="field-odd"><p>array of length len(R) or len(t)</p>
</dd>
</dl>
</dd></dl>

<dl class="method">
<dt id="rm_new.element.gamma">
<code class="sig-name descname">gamma</code><span class="sig-paren">(</span><em class="sig-param">R</em>, <em class="sig-param">t</em>, <em class="sig-param">param</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/rm_new.html#element.gamma"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#rm_new.element.gamma" title="Permalink to this definition">¶</a></dt>
<dd><p>radial metallicity profile: straight line
time dependency: f(t) = (1-t/tmax)**gamma</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>R</strong> (<em>array</em>) – galactocentric radius [kpc]</p></li>
<li><p><strong>t</strong> (<em>array</em>) – age [Gyr]</p></li>
<li><p><strong>param</strong> (<em>object of model parameters</em>) – param.Rs = radius of solar abundance [kpc]
param.gamma = gamma exponent for time (0-1)
param.grad = abundance gradient (dex/kpc)</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>[X/H](R, t)</p>
</dd>
<dt class="field-odd">Return type</dt>
<dd class="field-odd"><p>array</p>
</dd>
</dl>
</dd></dl>

</dd></dl>

<dl class="function">
<dt id="rm_new.p_migration_drift">
<code class="sig-prename descclassname">rm_new.</code><code class="sig-name descname">p_migration_drift</code><span class="sig-paren">(</span><em class="sig-param">Lz</em>, <em class="sig-param">t</em>, <em class="sig-param">L0</em>, <em class="sig-param">vc0</em>, <em class="sig-param">pm</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/rm_new.html#p_migration_drift"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#rm_new.p_migration_drift" title="Permalink to this definition">¶</a></dt>
<dd><p>Distribution of angular momentum a time t after birth at Lz0 due to stellar
radial migration</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>Lz</strong> (<em>array</em>) – current angular momentum [kpc km/s]</p></li>
<li><p><strong>t</strong> (<em>array</em>) – time or age [Gyr]</p></li>
<li><p><strong>Lz0</strong> (<em>array</em>) – angular momentum t time ago</p></li>
<li><p><strong>pm</strong> (<em>model parameters class instance</em>) – need pm.srm: radial migration strength [kpc km/s]</p></li>
<li><p><strong>vc0</strong> (<em>array</em>) – circular velocity [km/s]</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>pdf of (Lz | Lz0, t)</p>
</dd>
<dt class="field-odd">Return type</dt>
<dd class="field-odd"><p>array</p>
</dd>
</dl>
<p class="rubric">Notes</p>
<p>Implements radial migration</p>
<div class="math notranslate nohighlight">
\[p(L_z | L_{z0}, \sigma_{Lzo}, \tau) \propto \exp{\left(-\frac{(L_z - L_{zo0} - D^{(1)}\tau)^2}{2\sigma^2(\tau)}\right)}\]</div>
</dd></dl>

<dl class="function">
<dt id="rm_new.p_migration_radius">
<code class="sig-prename descclassname">rm_new.</code><code class="sig-name descname">p_migration_radius</code><span class="sig-paren">(</span><em class="sig-param">R</em>, <em class="sig-param">t</em>, <em class="sig-param">R0</em>, <em class="sig-param">pm</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/rm_new.html#p_migration_radius"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#rm_new.p_migration_radius" title="Permalink to this definition">¶</a></dt>
<dd><p>distribution of angular momentum a time t after birth at Lz0</p>
<p>arguments:
Lz current angular momentum [kpc km/s]
t time or age [Gyr]
Lz0 angular momentum t time ago
sigma: radial migration strength [kpc km/s]
vc0 circular velocity [km/s]
Rd = disk scale length [kpc]</p>
<p>returns: pdf of (Lz | Lz0, t)</p>
</dd></dl>

<dl class="function">
<dt id="rm_new.vel_disp_r">
<code class="sig-prename descclassname">rm_new.</code><code class="sig-name descname">vel_disp_r</code><span class="sig-paren">(</span><em class="sig-param">Rc</em>, <em class="sig-param">t</em>, <em class="sig-param">pm</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/rm_new.html#vel_disp_r"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#rm_new.vel_disp_r" title="Permalink to this definition">¶</a></dt>
<dd><p>velocity dispersion as a function of time and guiding radius
increases with age (heating) as about t**0.33
and decays exponentially radially
Binney 2012 quasi isothermal distribution functions</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>Rc</strong> (<em>array</em>) – guiding radius of the orbit (kpc)</p></li>
<li><p><strong>t</strong> (<em>array</em>) – stellar ages (time after birth)</p></li>
<li><p><strong>pm</strong> (<em>model parameters class instance</em>) – <dl class="simple">
<dt>the important ones are</dt><dd><p>pm.vel_disp_r0  (km/s) ~ vel disp at solar radius
pm.Rd_heating   (kpc) decline of velocity dispersion
pm.R0           (kpc) solar radius
pm.t1           (Gyr) 0.11
pm.tt
pm.beta         power law time evolution 0.33</p>
</dd>
</dl>
</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p></p>
</dd>
<dt class="field-odd">Return type</dt>
<dd class="field-odd"><p>the velocity dispersion at that place and time (km/s)</p>
</dd>
</dl>
</dd></dl>

<dl class="function">
<dt id="rm_new.p_heating">
<code class="sig-prename descclassname">rm_new.</code><code class="sig-name descname">p_heating</code><span class="sig-paren">(</span><em class="sig-param">Jr</em>, <em class="sig-param">k</em>, <em class="sig-param">sigma_r</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/rm_new.html#p_heating"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#rm_new.p_heating" title="Permalink to this definition">¶</a></dt>
<dd><p>Distribution of radial action due to radial heating</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>Jr</strong> (<em>array</em>) – radial action [kpc km/s]</p></li>
<li><p><strong>k</strong> (<em>array</em>) – epicycle freqency</p></li>
<li><p><strong>sigma_r</strong> (<em>array</em>) – velocity dispersion [km/s]</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>value of the probability distribution function</p>
</dd>
<dt class="field-odd">Return type</dt>
<dd class="field-odd"><p>array</p>
</dd>
</dl>
<p class="rubric">Notes</p>
<p>Implements standard quasi-isothermal distribution functions (Binney), Frankel+20 eq.xx</p>
<div class="math notranslate nohighlight">
\[p(J_R | \sigma_R, \kappa) = \frac{1}{2\pi\sigma_R^2}\kappa\exp(-J_R\kappa/\sigma_R^2)\]</div>
<p>History:</p>
<p>2020 frankel</p>
</dd></dl>

<dl class="function">
<dt id="rm_new.p_z">
<code class="sig-prename descclassname">rm_new.</code><code class="sig-name descname">p_z</code><span class="sig-paren">(</span><em class="sig-param">R</em>, <em class="sig-param">R0</em>, <em class="sig-param">tau</em>, <em class="sig-param">z</em>, <em class="sig-param">az=1</em>, <em class="sig-param">pm=None</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/rm_new.html#p_z"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#rm_new.p_z" title="Permalink to this definition">¶</a></dt>
<dd><p>Vertical isothermal distribution for the Galactic disk
as a function of Galactocentric radius and age. Based on
Ting and Rix analysis of the vertical heating history
of the Galactic disk.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>R</strong> (<em>array</em>) – present-day radius (kpc)</p></li>
<li><p><strong>R0</strong> (<em>array</em>) – birth radius (kpc)</p></li>
<li><p><strong>z</strong> (<em>array</em>) – height above the Galactic plane (kpc)</p></li>
<li><p><strong>h</strong> (<em>array</em>) – scale_height(R, R0, tau), kpc
return sech2(z/h)/(2*h)</p></li>
<li><p><strong>az</strong> (<em>float</em>) – default: 1
scaling factor to calibrate between Ting’s and Frankel’s models</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p><dl class="simple">
<dt>p_z(z | R0, R, t) = proba of being at height z given</dt><dd><p>the R0, R and age of a star</p>
</dd>
</dl>
</p>
</dd>
<dt class="field-odd">Return type</dt>
<dd class="field-odd"><p>array</p>
</dd>
</dl>
<p class="rubric">Notes</p>
<p>Implements isothermal sech2 distribution</p>
<div class="math notranslate nohighlight">
\[p_z(z | R_0, R, t) = sech2(z/h_z(R,R_0,\tau))/(2*h_z(R,0,\tau))\]</div>
</dd></dl>

</div>
<div class="section" id="milpyway-fit-model">
<h2><code class="docutils literal notranslate"><span class="pre">MilpyWay.fit_model</span></code><a class="headerlink" href="#milpyway-fit-model" title="Permalink to this headline">¶</a></h2>
<dl class="function">
<dt id="fit_model.global_model_R0">
<code class="sig-prename descclassname">fit_model.</code><code class="sig-name descname">global_model_R0</code><span class="sig-paren">(</span><em class="sig-param">Lz</em>, <em class="sig-param">Jr</em>, <em class="sig-param">z</em>, <em class="sig-param">t</em>, <em class="sig-param">R0</em>, <em class="sig-param">pm</em>, <em class="sig-param">frc=False</em>, <em class="sig-param">return_components=False</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/fit_model.html#global_model_R0"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#fit_model.global_model_R0" title="Permalink to this definition">¶</a></dt>
<dd><p>Global model for the galactic disk
Extended distribution functions</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>Lz</strong> (<em>array</em>) – angular momentum</p></li>
<li><p><strong>JR</strong> (<em>array</em>) – radial action</p></li>
<li><p><strong>z</strong> (<em>array</em>) – height above the plane [kpc]</p></li>
<li><p><strong>t</strong> (<em>array</em>) – age [Gyr]</p></li>
<li><p><strong>R0</strong> (<em>array</em>) – birth radius [kpc]</p></li>
<li><p><strong>pm</strong> (<em>class instance</em>) – model parameters object</p></li>
<li><p><strong>el_name</strong> (<em>list of strings</em>) – [‘element_name’] as named in enrichment param</p></li>
<li><p><strong>frc</strong> (<em>boolean</em>) – set to False by default</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>global model</p>
</dd>
<dt class="field-odd">Return type</dt>
<dd class="field-odd"><p>array</p>
</dd>
</dl>
<p class="rubric">Notes</p>
<p>History:</p>
<p>2019-05-12 frankel</p>
</dd></dl>

<dl class="function">
<dt id="fit_model.global_model">
<code class="sig-prename descclassname">fit_model.</code><code class="sig-name descname">global_model</code><span class="sig-paren">(</span><em class="sig-param">Lz</em>, <em class="sig-param">Jr</em>, <em class="sig-param">z</em>, <em class="sig-param">t</em>, <em class="sig-param">fe</em>, <em class="sig-param">pm</em>, <em class="sig-param">el_name</em>, <em class="sig-param">frc=False</em>, <em class="sig-param">enrichment_prescription='gamma'</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/fit_model.html#global_model"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#fit_model.global_model" title="Permalink to this definition">¶</a></dt>
<dd><p>Global model for the galactic disk
Extended distribution functions</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>Lz</strong> (<em>array</em>) – angular momentum</p></li>
<li><p><strong>JR</strong> (<em>array</em>) – radial action</p></li>
<li><p><strong>z</strong> (<em>array</em>) – height above the plane [kpc]</p></li>
<li><p><strong>t</strong> (<em>array</em>) – age [Gyr]</p></li>
<li><p><strong>fe</strong> (<em>array</em>) – metallicity [dex]</p></li>
<li><p><strong>pm</strong> (<em>class instance</em>) – moddel parameters object</p></li>
<li><p><strong>el_name</strong> (<em>list of strings</em>) – [‘element_name’] as named in enrichment param</p></li>
<li><p><strong>frc</strong> (<em>boolean</em>) – set to False by default</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>global model</p>
</dd>
<dt class="field-odd">Return type</dt>
<dd class="field-odd"><p>array</p>
</dd>
</dl>
<p class="rubric">Notes</p>
<p>History:</p>
<p>2019-06-03 frankel</p>
</dd></dl>

<dl class="function">
<dt id="fit_model.data_model_fe_obs">
<code class="sig-prename descclassname">fit_model.</code><code class="sig-name descname">data_model_fe_obs</code><span class="sig-paren">(</span><em class="sig-param">Data</em>, <em class="sig-param">p_obs</em>, <em class="sig-param">q_dist</em>, <em class="sig-param">el_name</em>, <em class="sig-param">pm</em>, <em class="sig-param">frc=False</em>, <em class="sig-param">log=False</em>, <em class="sig-param">enrichment_prescription='gamma'</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/fit_model.html#data_model_fe_obs"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#fit_model.data_model_fe_obs" title="Permalink to this definition">¶</a></dt>
<dd><p>model in the data coordinates, accounting for uncertainties
(no selection function in there)</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>Data</strong> (<em>list of arrays</em>) – contains D, z, Lz, Jr, t, feh: the measured ‘observables’
[D =  dist (kpc)
Lz, Jr = azimuthal and radial actions –&gt; ndarray(Nobs, N_MC)
t = age (Nobs, N_MC)
Fe]  = metallicity (Nobs,)</p></li>
<li><p><strong>p_obs</strong> (<em>array</em>) – values of the noise model</p></li>
<li><p><strong>q_dist</strong> (<em>array</em>) – values of the pdf that generated the data</p></li>
<li><p><strong>el_name</strong> (<em>list of strings</em>) – [‘element_name’]</p></li>
<li><p><strong>pm</strong> (<em>class instance</em>) – model parameters</p></li>
<li><p><strong>frc</strong> (<em>boolean</em>) – default: false</p></li>
<li><p><strong>log</strong> (<em>boolean</em>) – deflaut: false</p></li>
<li><p><strong>enrichment_prescription</strong> (<em>string</em>) – default: ‘gamma’ corresponds to the chemical enrichment model one wants to use,
as listed in rm_new.element</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p><ul class="simple">
<li><p><em>array</em></p></li>
<li><p><em>the model values marginalized over observational uncertainties</em></p></li>
<li><p><em>int p(l, b, D, vphi, vr, t, R0 | pm)</em> – x p_obs(vphi_obs, vr_obs, t_obs | vphi, vr, t) dvphi dvr dt</p></li>
</ul>
</p>
</dd>
</dl>
<p class="rubric">Notes</p>
<p>History:</p>
<p>2019-06-24 frankel</p>
</dd></dl>

<dl class="function">
<dt id="fit_model.likelihood_obs">
<code class="sig-prename descclassname">fit_model.</code><code class="sig-name descname">likelihood_obs</code><span class="sig-paren">(</span><em class="sig-param">pm_array</em>, <em class="sig-param">pm_names</em>, <em class="sig-param">data_s</em>, <em class="sig-param">data_norm</em>, <em class="sig-param">p_obs</em>, <em class="sig-param">q_dist</em>, <em class="sig-param">p_samples</em>, <em class="sig-param">pm_object</em>, <em class="sig-param">el_name=None</em>, <em class="sig-param">frc=False</em>, <em class="sig-param">enrichment_prescription='gamma'</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/fit_model.html#likelihood_obs"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#fit_model.likelihood_obs" title="Permalink to this definition">¶</a></dt>
<dd><p>2019-06-24</p>
<p>compute the likelihood of having the observed data drawn
from the model parameters pm_object</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>pm_array</strong> (<em>array</em>) – values of the model parameters to fit (or to evaluate the likelihood for)</p></li>
<li><p><strong>pm_names</strong> (<em>list of strings</em>) – keys corresponding to the model parameters in pm_array (to initialize the
model parameters object with these). One may decide to fit only for a
subset of the overal model parameters so this is handy: just give a list
of those you want to fit.</p></li>
<li><p><strong>data_s</strong> (<em>list of arrays</em>) – data to fit: [D, z, Lz, Jr, t, feh] with
D: distance (kpc)
z: height above the midplane (kpc)
Lz: angular momentum (kpc km/s)
Jr: radial action (kpc km/s)
t: Age (Gyr)
feh: [Fe/H] or other element, [dex]</p></li>
<li><p><strong>data_norm</strong> (<em>arrays</em>) – samples used to compute the normalizing integral (Survey volume)
Not needed if all model parameters related to SFR, structure, or dynamics are fixed</p></li>
<li><p><strong>p_obs</strong> (<em>array</em>) – noise model evaluated on the data points of data_s = p_obs(data_s)</p></li>
<li><p><strong>q_dist</strong> (<em>array</em>) – values of the pdf that generated the samples used to marginalize
over observational uncertainties = q_obs(data_s)</p></li>
<li><p><strong>p_samples</strong> (<em>array</em>) – values of the model on the samples used to compute the survey volume
Not needed if all model parameters are fixed</p></li>
<li><p><strong>pm_object</strong> (<em>class instance</em>) – model parameters object, that is associated with pm_array and pm_names</p></li>
<li><p><strong>el_name</strong> (<em>list of strings</em>) – name of the elements to fit for [‘Fe’]</p></li>
<li><p><strong>frc</strong> (<em>boolean</em>) – default: False</p></li>
<li><p><strong>enrichment_prescription</strong> (<em>string</em>) – default: ‘gamma’
chemical enrichment prescription as coded in rm_new.element (‘expo’, ‘Weinberg’)</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>likelihood evaluated on the model parameter pm_names in pm_array</p>
</dd>
<dt class="field-odd">Return type</dt>
<dd class="field-odd"><p>float</p>
</dd>
</dl>
</dd></dl>

</div>
</div>


           </div>
           
          </div>
          <footer>
    <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
        <a href="intro.html" class="btn btn-neutral float-left" title="Introduction" accesskey="p" rel="prev"><span class="fa fa-arrow-circle-left" aria-hidden="true"></span> Previous</a>
    </div>

  <hr/>

  <div role="contentinfo">
    <p>
        &#169; Copyright 2021, Neige Frankel.

    </p>
  </div>
    
    
    
    Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    
    provided by <a href="https://readthedocs.org">Read the Docs</a>. 

</footer>
        </div>
      </div>

    </section>

  </div>
  

  <script type="text/javascript">
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script>

  
  
    
   

</body>
</html>